package Ukagaka::Shiori::Engine;
use utf8;

sub new{
	my $package = shift;
	my $option = shift;
	my $replacedata = shift;
	my $securitylevel = $option->{securitylevel};
	my $data = {
		shiori => {
			version => '1.0',
			craftman => '奈良阪某',
			craftmanw => 'Narazaka',
			shioriid => 'Shiolink_Perl_ShioriEngine_None',
			name => 'Shiolink/Perl ShioriEngine_None',
		},
		header => {
			Charset => 'UTF-8',
			Sender => 'Shiolink/Perl' # default sender (will be overwritten)
		},
		system => {
			acceptversion => '3.0',
			loaddir => ''
		},
		securitylevel => $securitylevel # IN CASE OF FIRE BREAK GLASS
	};
	$data->{$_} = $replacedata->{$_} for keys %$replacedata;
	sub accesser:lvalue{ # accesser for any depth data structure
		my $elem = shift;
		my $field = shift;
		my @restfields = @_;
		if(!defined $field){
			return $elem;
		}elsif(ref $elem eq 'ARRAY'){
			accesser($elem->[$field],@restfields);
		}elsif(ref $elem eq 'HASH'){
			accesser($elem->{$field},@restfields);
		}else{
			return $elem;
		}
	}
	my $self = sub{ # return bless closure in order to enable access check (anyone can access data structure only by using accesser)
		my $value = shift;
		my @fields = @_;
		if(defined $value && $fields[0] ne 'securitylevel'){ # securitylevel is readonly
			accesser($data,@fields) = $value;
		}
		return accesser($data,@fields);
	};
	return bless $self,$package;
}

# Accesser
sub shiori{shift->(undef,'shiori')} # Returns hash reference -> can overwrite
sub header{shift->(undef,'header')} # Returns hash reference -> can overwrite
sub system{shift->(undef,'system')} # Returns hash reference -> can overwrite
sub acceptversion:lvalue{shift->system->{acceptversion}} # Returns lvalue -> can overwrite
sub loaddir:lvalue{shift->system->{loaddir}} # Returns lvalue -> can overwrite
sub securitylevel{shift->(undef,'securitylevel')} # Returns scalar -> cannot overwrite!

# Shiori framework
sub init{
	my $self = shift;
}

sub end{
	my $self = shift;
}

sub callback{
	my $self = shift;
	my $method = shift;
	my $type = shift;
	my $version = shift;
	my $request = shift;
	my $statuscode = 204;
	my $responce = {
		Charset => $self->header->{Charset},
		Sender => $self->header->{Sender}
	};
	return $type,$version,$statuscode,$responce;
}

1;
