package Ukagaka::Shiori::Engine::Kawari;
use utf8;
use Ukagaka::Shiori::Engine;
use Ukagaka::Shiori::Engine::Kawari::Dict;
use Ukagaka::Shiori::Engine::Kawari::Kis;

our @ISA = qw(Ukagaka::Shiori::Engine);
# our @ISA = qw(Shiori::Engine::Kawari::Kis);

sub new{
	my $package = shift;
	my $option = shift;
	my $dictfiles = $option->{dict} || ['./kawarirc.kis'];
	my $dict = Ukagaka::Shiori::Engine::Kawari::Dict->new();
	$dict->load(@$dictfiles);
	my $kis = Ukagaka::Shiori::Engine::Kawari::Kis->new($dict);
	$option->{securitylevel} = 2 unless $option->{securitylevel};
	my $data = {
		shiori => {
			version => '1.0',
			craftman => '奈良阪某',
			craftmanw => 'Narazaka',
			shioriid => 'Shiolink_Perl_ShioriEmulateEngine_Kawari',
			name => 'Shiolink_Perl ShioriEmulateEngine_Kawari'
		},
		header => {
			Sender => 'Shiolink/Perl'
		},
		system => {
			acceptversion => '3.0',
			loaddir => ''
		},
		kis => $kis
	};
	my $self = Ukagaka::Shiori::Engine->new($option,$data);
	return bless $self,$package;
}

my $kis = sub{shift->(undef,'kis')}; # works like private method -> events cannot overwrite

sub callback{
	my $self = shift;
	my $method = shift;
	my $type = shift;
	my $version = shift;
	my $request = shift;
	$self->$kis->setstr('System.Request',$method);
	$self->$kis->setstr('System.Request.' . $_,$request->{$_}) for keys %$request;
	$self->$kis->setstr('System.SecurityLevel',$self->securitylevel);
	$self->$kis->cleartree('System.Response');
	my $responce;
	if($method eq 'GET'){
		if($request->{ID} eq 'ShioriEcho'){
			if($self->{'System.Debugger'}->value(0) eq 'on'){
				$responce->{Value} = $self->{'System.Request.Reference0'}->value(0);
				$self->clear('System.Request.Reference0');
			}
		}else{
			$responce->{Value} = $self->get('System.Callback.OnGet');
			if(!$responce->{Value}){
				if($request->{ID} eq 'version'){
					$responce->{Value} = $version;
				}elsif($request->{ID} eq 'craftman'){
					$responce->{Value} = $craftman;
				}elsif($request->{ID} eq 'craftmanw'){
					$responce->{Value} = $craftmanw;
				}elsif($request->{ID} eq 'shioriid'){
					$responce->{Value} = $shioriid;
				}elsif($request->{ID} eq 'name'){
					$responce->{Value} = $name;
				}
			}
		}
	}
	$responce->{Sender} = 'GHOST_NAME';# 未実装
	$responce->{Charset} = 'UTF-8';
	# 先に入っていた値は変わらない
	$responce->{$_} = $responce->{$_} || $self->{'System.Response.' . $_}->value(0) for map {s/^System\.Response\.//;$_} $self->listchild('System.Response');
	my $responcecode = $responce->{Value} ? '200 OK' : '204 No Content';
	return $responcecode,$responce;
}

1;
