package Ukagaka::Shiori::Engine::Kawari::Dict;
use utf8;
use Ukagaka::Shiori::Engine::Kawari::Dict::Value::Analize;
use Ukagaka::Shiori::Engine::Kawari::Dict::Value::Tree;

sub new{
	my $package = shift;
	my $hash = {};
	return bless $hash,$package;
}

sub load{
	my $self = shift;
	my @dictfiles = @_;
	for my $dicfile (@dictfiles){
#print STDERR "dics=@$dictfiles\n";###
		open my $fh,'<:utf8',$dicfile;
		my $keylist;
		my $entryvalue;
		$entryvalue = Ukagaka::Shiori::Engine::Kawari::Dict::Value::Analize->new();
		my $kisvalue = Ukagaka::Shiori::Engine::Kawari::Dict::Value::Analize->new('cmd');
		my @mode = ();
		my $commentflag = 0;
		while(<$fh>){
			chomp;
#print STDERR "\n_=$_\n";###
			if(/^[ \t]*(?:#.*)?$/){ # コメント・空白行をスキップ
				next;
			}elsif(/^:rem$/){
				$commentflag = 1;
			}elsif(/^:endrem$/){
				$commentflag = 0;
			}elsif($commentflag){
				next;
			}elsif(/^=kis$/){
				push @mode,'kis';
			}elsif(/^=dict$/){
				push @mode,'dict';
			}elsif(/^=end$/){
				pop @mode;
			}elsif(/^:\w+$/){
				next;
			}else{
				if($mode->[-1] eq 'kis'){
					$kisvalue->analize($_);
				}else{
					my ($key,$value);
					if(!$entryvalue->stackdepth()){ # 括弧の外
						($key,$value) = /^[ \t]*(.+?)[ \t]*:[ \t]*(.*)[ \t]*$/; # エントリのキーと値を分割
						die "Wrong format." unless defined $key;
						$keylist = [split /[ \t]*,[ \t]*/,$key]; # キーの分割
						$entryvalue = Ukagaka::Shiori::Engine::Kawari::Dict::Value::Analize->new();
					}else{
						$value = $_;
					}
#print STDERR "  keylist=@{[join '/',@$keylist]}\n";###
#print STDERR "  value  =$value\n";###
					my $ret = $entryvalue->analize($value);
					if($ret){
						$self->pushkey($keylist,$entryvalue->getvalue()->valuetree());
						#push @{$self->{$_}},$entryvalue->getvalue() for @$keylist;
#use Data::Dumper;
#print STDERR Data::Dumper->Dump($entryvalue->{value}->{valuetree});###
					}
				}
			}
		}
		close $fh;
		if($kisvalue->stackdepth() || $entryvalue->stackdepth()){
			die "Unmatch bracket.";
		}
		push @{$self->{'/'}},$kisvalue->getvalue();
#print STDERR "Fin.\n";###
#print "$_:",(join " | ",@{$self->{dic}->{$_}}),"\n" for sort keys %{$self->{dic}};
#print STDERR "$_:",(join "",map {$_->{bra}.$_->{value}.$self->{cket}->{$_->{bra}}->{join}} @{$self->{dic}->{$_}->[0]}),"\n" for sort keys %{$self->{dic}};
	}
	return undef;
}

sub pushkey{
	my $self = shift;
	my $keys = shift;
	my $values = shift;
	for my $key (@$keys){
		$self->{$key} = Ukagaka::Shiori::Engine::Kawari::Dict::Value::Tree->new() if ref $self->{$key} ne 'Ukagaka::Shiori::Engine::Kawari::Dict::Value::Tree';
	}
	$self->{$_}->pushvalue(@$values) for @$keys;
}

1;
