package Ukagaka::Shiori::Engine::Kawari::Dict::Value::Tree;
use utf8;

sub new{
	my $package = shift;
	my $type = shift;
	my $valuetree = shift || [];
	my $hash = {
		type => $type,
		valuetree => $valuetree
	};
	return bless $hash,$package;
}

our $bracket = {
	'' => ['',''],
	'plain' => ['',''],
	'cmd' => ['$(',')'],
	'call' => ['${','}'],
	'expr' => ['$[',']']
};

# overload
${'Ukagaka::Shiori::Engine::Kawari::Dict::Value::Tree::OVERLOAD'}{dummy}++;
*{'Ukagaka::Shiori::Engine::Kawari::Dict::Value::Tree::()'} = sub {};
*{'Ukagaka::Shiori::Engine::Kawari::Dict::Value::Tree::(""'} = sub { # tostring
	my $self = shift;
	my $str;
	$str= $bracket->{$self->{type}}->[0];
	$str .= $_ for @{$self->{valuetree}};
	$str .= $bracket->{$self->{type}}->[1];
	return $str;
};
*{'Ukagaka::Shiori::Engine::Kawari::Dict::Value::Tree::(0+'} = sub { # tonumber
	my $self = shift;
	my $str;
#	$str .= parse($_) for @{$self->{valuetree}}; # parseは$_->{type}などを参照して解釈する。
	# $(aaa $(aaa))の場合、$(['aaa ',$(['aaa'])])という感じになっている
	# 自分の一階層下をパースする。つまり$(['aaa'])は文字列'bbb'として$(['aaa ',$(['aaa'])])にわたされ、$(['aaa ',$(['aaa'])])は$(['aaa bbb'])を返す。さらに外側のパースで$(['aaa bbb'])は解釈される。
	return $str;
};

sub gettype{
	my $self = shift;
	return $self->{type};
}

sub settype{
	my $self = shift;
	my $type = shift;
	$self->{type} = $type;
}

sub valuetree{
	my $self = shift;
	return $self->{valuetree};
}

sub size{
	my $self = shift;
	return $#{$self->{valuetree}};
}

sub value{ # パースされる(未実装)
	my $self = shift;
	my $index = shift;
	return defined $index ? $self->{valuetree}->[$index] : $self;
}

sub valuestr{ # パースされない
	my $self = shift;
	my $index = shift;
	return defined $index ? $self->{valuetree}->[$index] : $self;
}

sub lastvalue{
	my $self = shift;
	return $self->{valuetree}->[-1];
}

sub pushvalue{
	my $self = shift;
	my @value = @_;
	push @{$self->{valuetree}},@value;
}

sub popvalue{
	my $self = shift;
	return pop @{$self->{valuetree}};
}

1;
