package Ukagaka::Shiori::Engine::Perl::Events;
use utf8;

sub new{
	my $package = shift;
	my $hash = {
		value => {
			OnBoot => '\0\s[0]\1\s[10]\e',
			OnGhostChanged => '\0\s[0]\1\s[10]\e',
			OnClose => '\-'
		}
	};
	return bless $hash,$package;
}

# Perl default

sub AUTOLOAD{
	our $AUTOLOAD;
	my $self = shift;
	my @argv = @_;
	my $pkgname = ref $self;
	$AUTOLOAD =~ s/^${pkgname}:://;
	print STDERR "Not implemented event : $AUTOLOAD\n";
	return $self->{value}->{$AUTOLOAD};
}

sub DESTROY{
	my $self = shift;
}

# Events by ID/Event header

sub OnBoot{
	my $self = shift;
	my $request = shift;
	my ($value,$statuscode,$headers);
	$value = $self->{value}->{OnBoot};
	return $value,$statuscode,$headers;
}

sub OnFirstBoot{
	goto &OnBoot;
}

sub OnGhostChanged{
	my $self = shift;
	my $request = shift;
	my ($value,$statuscode,$headers);
	$value = $self->{value}->{OnGhostChanged};
	return $value,$statuscode,$headers;
}

sub OnClose{
	my $self = shift;
	my $request = shift;
	my ($value,$statuscode,$headers);
	$value = $self->{value}->{OnClose};
	return $value,$statuscode,$headers;
}

sub OnCloseAll{
	goto &OnClose;
}

# Legacy callback methods

sub Sentence{
	my $self = shift;
	my $request = shift;
	my ($sentence,$statuscode,$headers);
	return $sentence,$statuscode,$headers;
}

sub Word{
	my $self = shift;
	my $request = shift;
	my $word;
	return $word;
}

sub Status{
	my $self = shift;
	my $request = shift;
	my $status;
	return $status;
}

sub TEACH{
	my $self = shift;
	my $request = shift;
	my ($sentence,$statuscode);
	return $sentence,$statuscode;
}

1;
