# our $eventspackage にイベント応答を定義するパッケージ名を指定してください。
# init.plでのUkagaka::Shiori->newでの引数に使われ、Ukagaka::Shiori::Engine::Perlから呼ばれます。
our $eventspackage = 'Ukagaka::Shiori::Engine::Perl::Events::Sample';
# our $eventspackage に指定したパッケージ名でイベント応答を定義していきます。
# イベント応答定義パッケージは最初に
# use Ukagaka::Shiori::Engine::Perl::Events;
# our @ISA = ('Ukagaka::Shiori::Engine::Perl::Events');
# してUkagaka::Shiori::Engine::Perl::Eventsを継承しなければなりません。
# イベントやその他のメソッドは適宜オーバーライドしてください。
# 注意:イベント名で呼ばれるメソッド名の.は_に変換されています。
package Ukagaka::Shiori::Engine::Perl::Events::Sample;
use Ukagaka::Shiori::Engine::Perl::Events;
use utf8;
our @ISA = ('Ukagaka::Shiori::Engine::Perl::Events');

sub new{
	my $package = shift;
	my $hash = {
		value => {
			OnBoot => '\0\s[0]\1\s[1]\0ゴーストが起動されました。\e',
			OnGhostChanged => '\0\s[0]\1\s[10]\0ゴーストが変更されました。\e',
			OnGhostChanging => '\0\s[0]\1\s[10]\0ゴーストが変更されます。\e',
			OnClose => '\0\s[0]\1\s[10]\0ゴーストが終了されます。\w5\-',
			homeurl => 'http://narazaka.net/c/ukagaka/update/shiolink_perl/'
		}
	};
	return bless $hash,$package;
}

sub ret{
	my $list = ref $_[0] ? $_[0] : [@_];
	my $num = rand $#$list + 1;
	my $ret = $list->[$num];
	$ret =~ s/[\n\r]//g;
	return $ret;
}

sub value:lvalue{
	my $self = shift;
	my $id = shift;
	return defined $id ? $self->{value}->{$id} : $self->{value};
}

sub AUTOLOAD{
	our $AUTOLOAD;
	my $self = shift;
	my @argv = @_;
	my $pkgname = ref $self;
	$AUTOLOAD =~ s/^${pkgname}:://;
	print STDERR "Not implemented event : $AUTOLOAD\n";
	return ret $self->value($AUTOLOAD);
}

sub OnBoot{ret shift->value('OnBoot')}

sub OnFirstBoot{ret <<'EOM'
\h\s[0]\u\s[10]\u
Shiolink/Perl\w6\n
 Powered by SHIOLINK(shiori-basic)\n
 Author: Narazaka\w9\n\n[half]
 running...\w4
\h
このゴーストは、\w4\n
Shiolink/Perl ShioriEngine_Perl/1.0\n
のデモです。\w9\w5\n\n[half]
Shiolink/PerlはSHIOLINK.dllとPerlの連携でSHIORIを実装するフレームワークです。\w9\w5\n
ShioriEngine_PerlはShiolink/Perlフレームワークの中でPerl独自の自由な処理実装を目指して作られた基本エンジンです。\w9\w9\n\n[half]
このゴーストはShioriEngine_Perlエンジンの実装を継承したイベント処理サンプルパッケージで動いています。\w9\w5\n
ghost/master/scripts/events.plにShiori::Engine::Perl::Eventsを継承したイベント応答を自由に実装することで、\w4ShioriEngine_Perlは完成します。\w9\w5\n\n[half]
いくつかのイベント応答実装サンプルがghost/master/scripts/events-*.plにありますので、\w4適宜参考にしてそれぞれの実装を作り上げていってください。\w9\w5\n
なおこれらの実装サンプルは、\w4init.plのrequire行を書き換えるだけで簡単に交換してためすことができます。\w9\w9\n\n[half]
それではデフォルトでなんの応答もしませんが、\w4とりあえずPerlで栞が動いてる感(ないけど)を味わってください。
\e
EOM
}

1;
